<template lang="pug">
  .container-text
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[0]) || !isDetailsEnough(details[1]) || !isDetailsEnough(details[2])'
      ) Для производства биоробота не хватает
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[0])'
      )  {{howManyDetailsNotEnough(details[0])}}
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[0])'
      )  биомеханизма
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[1]) && !isDetailsEnough(details[0])'
      ) ,
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[1])'
      )  {{howManyDetailsNotEnough(details[1])}}
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[1])'
      )  процессора
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[2]) && !isDetailsEnough(details[1]) || !isDetailsEnough(details[2]) && !isDetailsEnough(details[0])'
      )  и
    BaseText.not-enough-text(
      size='text-smallest'
      skin='grey'
      weight='weight500'
      v-if='!isDetailsEnough(details[2])'
      )  души
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'

import { ProductionModule } from '../../store/modules/production/index'
import { PurseModule } from '../../store/modules/purse/index'
import IDetail from '../../store/modules/production/interfaces'
import declOfNum from '../../utils/declOfNum'
import BaseText from '../BaseText.vue'

@Component({
  components: {
    BaseText
  }
})
export default class TextNotEnoughDetails extends Vue {
  get details () {
    return ProductionModule.details
  }

  isDetailsEnough (detail: IDetail) {
    return detail.installed.filter((i: boolean) => i === true).length === detail.need
  }

  howManyDetailsNotEnough (detail: IDetail) {
    if (detail.need - detail.installed.filter((i: boolean) => i === true).length !== 0) {
      return detail.need - detail.installed.filter((i: boolean) => i === true).length
    } else {
      return ''
    }
  }
}
</script>

<style lang="scss" scoped>
.container-text {
  width: 195px;
  height: 48px;
}

.not-enough-text {
  display: inline;
}
</style>
